Index: res/res_musiconhold.c
===================================================================
--- res/res_musiconhold.c	(revision 73759)
+++ res/res_musiconhold.c	(working copy)
@@ -930,17 +930,18 @@
 	 *    option.
 	 * 4) The default class.
 	 */
+	AST_LIST_LOCK(&mohclasses);
 	if (!ast_strlen_zero(chan->musicclass))
-		class = chan->musicclass;
-	else if (!ast_strlen_zero(mclass))
-		class = mclass;
-	else if (!ast_strlen_zero(interpclass))
-		class = interpclass;
-	else
-		class = "default";
+		mohclass = get_mohbyname(chan->musicclass);
 
-	AST_LIST_LOCK(&mohclasses);
-	mohclass = get_mohbyname(class);
+	if (!mohclass && !ast_strlen_zero(mclass))
+		mohclass = get_mohbyname(mclass);
+
+	if (!mohclass && !ast_strlen_zero(interpclass))
+		mohclass = get_mohbyname(interpclass);
+	
+	if (!mohclass)
+		mohclass = get_mohbyname("default");
 	AST_LIST_UNLOCK(&mohclasses);
 
 	if (!mohclass) {
